]> git.pld-linux.org Git - packages/rpm-build-macros.git/blame - rpm.macros
- rev 1.282, new libdir for modular xorg.
[packages/rpm-build-macros.git] / rpm.macros
CommitLineData
397b586d 1# $Revision$, $Date$
d54662bf
AF
2# PLD rpm macros
3
e05017c1 4%epoch 0
3241033b 5%x8664 x86_64 amd64 ia32e
9c404149 6
ba1fdedc 7# kernel compiler
345d14e5 8%kgcc %{__cc}
d2e1bc22 9%kgcc_package gcc
ba1fdedc 10
3241033b
ER
11%_source_payload w9.gzdio
12%_binary_payload w9.bzdio
13
33040789 14# Build system path macros.
15#
bddadece
JB
16%__autoconf autoconf %{?debug:-Wall}
17%__automake automake -a -c -f --foreign
f93109a0 18%__autopoint autopoint --force
19
83094b62 20%__gettextize { \
3241033b 21if ! gettextize --version | grep -q '0\.10\.' ; then \
8a995cff 22 if grep -qs 'AM_GNU_GETTEXT.*external' configure.{ac,in} ; then \
3241033b 23 gettextize --copy --force --no-changelog; \
97589b6e 24 else \
3241033b 25 gettextize --copy --force --no-changelog --intl; \
8a995cff
JB
26 fi; \
27 if [ ! -f po/Makevars ]; then \
3241033b 28 cp -f po/Makevars{.template,}; \
8a995cff 29 fi; \
3241033b 30else \
8a995cff 31 gettextize --copy --force; \
3241033b 32fi; \
8a995cff 33}
f93109a0 34
35%__glib_gettextize glib-gettextize --copy --force
36%__gnome_doc_common gnome-doc-common --copy
37%__gtkdocize gtkdocize --copy
38%__intltoolize intltoolize --copy --force
39%__libtoolize libtoolize --copy --force
33040789 40
6a5eda77 41%dependencytracking %{nil}
3241033b 42
e5da9169
ER
43# Relations between package names that cause dependency loops
44# with legacy packages that cannot be fixed. Relations are
45# specified as
46# p>q
47# where package p has a Requires: on something that package q Provides:
48#
49# XXX Note: that there cannot be any whitespace within the string "p>q",
50# and that both p and q are package names (i.e. no version/release).
51%_dependency_whiteout %{nil}
52
9c404149 53#-----------------------------------------------------------------
9f4ce098 54%configure2_13 { \
9c404149
AM
55 if [ -n "$LINGUAS" ]; then unset LINGUAS; fi; \
56 LDFLAGS="${LDFLAGS:-%rpmldflags}" ; export LDFLAGS ; \
57 CFLAGS="${CFLAGS:-%rpmcflags}" ; export CFLAGS ; \
f4cc8832 58 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" ; export CXXFLAGS ; \
9c404149 59 FFLAGS="${FFLAGS:-%rpmcflags}" ; export FFLAGS ; \
8ec1a12b 60 CPPFLAGS="${CPPFLAGS:-}" ; export CPPFLAGS ; \
8983c4c4
AM
61 %{?__cc:CC="%{__cc}" ; export CC ; } \
62 %{?__cxx:CXX="%{__cxx}" ; export CXX ; } \
8f74418b 63 %{?configuredir:%{configuredir}}%{!?configuredir:.}/configure \
2a7cfd3f 64 --host=%{_target_platform} \
9c404149
AM
65 --prefix=%{_prefix} \
66 --exec-prefix=%{_exec_prefix} \
67 --bindir=%{_bindir} \
68 --sbindir=%{_sbindir} \
69 --sysconfdir=%{_sysconfdir} \
70 --datadir=%{_datadir} \
71 --includedir=%{_includedir} \
72 --libdir=%{_libdir} \
73 --libexecdir=%{_libexecdir} \
74 --localstatedir=%{_localstatedir} \
75 --sharedstatedir=%{_sharedstatedir} \
76 --mandir=%{_mandir} \
77 --infodir=%{_infodir} \
5ff86d74 78 --x-libraries=%{_libdir} \
93059874 79 %{dependencytracking} \
9c404149
AM
80}
81
4a6b0d54 82#----------------------------------------------------------------
73f832b3 83%global configure_cache 0
84%configure_cache_file %{buildroot}.configure.cache
85
57f4166d 86%configure {./configure \
4a6b0d54
AF
87 LDFLAGS="${LDFLAGS:-%rpmldflags}" \
88 CFLAGS="${CFLAGS:-%rpmcflags}" \
f4cc8832 89 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
4a6b0d54 90 FFLAGS="${FFLAGS:-%rpmcflags}" \
a2bd5992 91 CPPFLAGS="${CPPFLAGS:-}" \
8983c4c4
AM
92 %{?__cc:CC="%{__cc}"} \
93 %{?__cxx:CXX="%{__cxx}"} \
8e4cb85a 94 --host=%{_target_platform} \
4a6b0d54
AF
95 --build=%{_target_platform} \
96 --prefix=%{_prefix} \
97 --exec-prefix=%{_exec_prefix} \
98 --bindir=%{_bindir} \
99 --sbindir=%{_sbindir} \
100 --sysconfdir=%{_sysconfdir} \
101 --datadir=%{_datadir} \
102 --includedir=%{_includedir} \
103 --libdir=%{_libdir} \
104 --libexecdir=%{_libexecdir} \
105 --localstatedir=%{_localstatedir} \
106 --sharedstatedir=%{_sharedstatedir} \
107 --mandir=%{_mandir} \
108 --infodir=%{_infodir} \
5ff86d74 109 --x-libraries=%{_libdir} \
93059874 110 %{dependencytracking} \
73f832b3 111 %{?configure_cache:--cache-file=%{configure_cache_file:-%{buildroot}.configure.cache}} \
4a6b0d54
AF
112}
113
7dbab518 114# ------------------------------------------------------------------------
c80506a3
AM
115# Overloading of some basic macros
116%prep \
117%%prep\
118LANG=C\
119export LANG\
14e77e64 120unset DISPLAY ||:\
6db5639d 121unset LINGUAS ||:\
c80506a3
AM
122%{nil}
123
124%build %%build\
125LANG=C\
126export LANG\
14e77e64 127unset DISPLAY ||:\
6db5639d 128unset LINGUAS ||:\
c80506a3
AM
129%{nil}
130
b4e3d367
ER
131%install \
132%if 0%{?_enable_debug_packages}\
133%{?buildsubdir:%{debug_package}}\
134%endif\
c80506a3
AM
135%%install\
136LANG=C\
137export LANG\
14e77e64 138unset DISPLAY ||:\
6db5639d 139unset LINGUAS ||:\
c80506a3
AM
140%{nil}
141
9c404149
AM
142# Location of autoconf macros
143%_aclocaldir %(aclocal --print-ac-dir)
144
e2804f99
AM
145# Location of omf files
146%_omf_dest_dir %(scrollkeeper-config --omfdir)
147
e987a186 148# Location of pkgconfig files
9a4e877a 149%_pkgconfigdir /usr/%{_lib}/pkgconfig
e987a186 150
486b0b5f 151# Location of desktop files
152%_desktopdir /usr/share/applications
86dff2d0 153%_applnkdir ERROR:_applnkdir_is_obsolete_use_desktopdir_instead
486b0b5f 154
481463e9 155# Location of pixmaps for applnk/desktop files
e1f0a822 156%_pixmapsdir /usr/share/pixmaps
9c404149 157
481463e9 158# Location of themable icons for applnk/desktop files
b36c8e2a 159%_iconsdir /usr/share/icons
160
e987a186
JB
161# Location of fonts directories
162%_fontsdir /usr/share/fonts
163
b3282f3f 164# Location of Gtk and associated libraries documentation
6eed6d84 165%_gtkdocdir %{_defaultdocdir}/gtk-doc/html
b3282f3f 166
fc4d7771 167# Location of KDE documentation
168%_kdedocdir %{_defaultdocdir}/kde/HTML
169
5869828c 170# unsermake script
171%__unsermake /usr/share/unsermake/unsermake
172
9c404149
AM
173# Current date
174%date %(LC_ALL="C" date +"%a %b %d %Y")
175
176# tmp directory
177%tmpdir %(echo "${TMPDIR:-/tmp}")
178
179# Example files, programs, scripts...
180%_examplesdir /usr/src/examples
181
8377d27d 182# The directory holding Linux kernel sources
183%_kernelsrcdir /usr/src/linux
184
9c404149 185# If non-empty "debug" macro defined, add "dbg" suffix to release number
8f74418b 186%_rpmfilename %%{NAME}-%%{VERSION}-%%{RELEASE}%{?debug:dbg}.%%{ARCH}.rpm
9c404149 187
8f74418b 188# Requires name = version-release
ec4e8b11 189%requires_releq() %(echo '%*' | LC_ALL="C" xargs -r rpm -q --qf 'Requires: %%{name} = %%{epoch}:%%{version}-%%{release}\\n' | sed -e 's/ (none):/ /' | grep -v "is not")
8bf3719d 190
c12095e9
PS
191%releq_kernel_up() %(LC_ALL="C" rpm -qf --qf '%%{name}-up = %%{epoch}:%%{version}-%%{release}\\n' %{_kernelsrcdir}/include/linux/version.h | sed -e 's/ (none):/ /' | sed -e 's:-headers::' | grep -vE "(is not|no such)")
192%releq_kernel_smp() %(LC_ALL="C" rpm -qf --qf '%%{name}-smp = %%{epoch}:%%{version}-%%{release}\\n' %{_kernelsrcdir}/include/linux/version.h | sed -e 's/ (none):/ /' | sed -e 's:-headers::' | grep -vE "(is not|no such)")
193%requires_releq_kernel_up() %(LC_ALL="C" rpm -qf --qf 'PreReq: %%{name}-up = %%{epoch}:%%{version}-%%{release}\\n' %{_kernelsrcdir}/include/linux/version.h | sed -e 's/ (none):/ /' | sed -e 's:-headers::' | grep -vE "(is not|no such)")
194%requires_releq_kernel_smp() %(LC_ALL="C" rpm -qf --qf 'PreReq: %%{name}-smp = %%{epoch}:%%{version}-%%{release}\\n' %{_kernelsrcdir}/include/linux/version.h | sed -e 's/ (none):/ /' | sed -e 's:-headers::' | grep -vE "(is not|no such)")
8bf3719d 195
47935449 196%requires_eq() %(echo '%*' | LC_ALL="C" xargs -r rpm -q --qf 'Requires: %%{name} = %%{epoch}:%%{version}\\n' | sed -e 's/ (none):/ /' -e 's/ 0:/ /' | grep -v "is not")
16cb1d91 197%requires_eq_to() %(LC_ALL="C" rpm -q --qf 'Requires: %1 = %%{epoch}:%%{version}\\n' %2 | sed -e 's/ (none):/ /' | grep -v "is not")
01a9f990 198
c0b2771b 199%apache_modules_api %(awk '/#define MODULE_MAGIC_NUMBER_MAJOR/ {print $3}' /usr/include/apache/ap_mmn.h 2>/dev/null || echo ERROR)
b9d5d440 200
201# kernel version-release handling
3241033b
ER
202%__kernel_ver %([ -f %{_kernelsrcdir}/include/linux/version.h ] && (grep UTS_RELEASE %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | head -n 1 | cut -d'"' -f2) || (awk '/^VERSION/ { ver = $0; gsub(/VERSION.*=/, NIL, ver); } /^PATCHLEVEL/ { plev = $0; gsub(/PATCHLEVEL.*=/, NIL, plev); } /^SUBLEVEL/ { slev = $0; gsub(/SUBLEVEL.*=/, NIL, slev); } /^EXTRAVERSION/ { ever = $0; gsub(/EXTRAVERSION.*=/, NIL, ever); gsub(/ /, NIL, ever); } END { printf("%d.%d.%d%s", ver, plev, slev, ever); }' %{_kernelsrcdir}/Makefile 2> /dev/null))
203%__kernel_rel %(LC_ALL="C" rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{RELEASE}" | grep -v "is not")
f004e915 204%__kernel_rpmvr %(LC_ALL="C" rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{VERSION}-%{RELEASE}" | grep -v "is not")
3241033b 205%_kernel_ver %{__kernel_ver}%{?with_dist_kernel:%(echo %{__kernel_ver} | grep -q -e - || echo -%{__kernel_rel})}
f62e856d 206%_kernel_ver_str %(echo %{!?_without_dist_kernel:%{__kernel_rpmvr}}%{?_without_dist_kernel:%{__kernel_ver}} | sed -e 's/-/_/g')
87be1cf0 207
e00dd7f6 208# sgml macros
3241033b
ER
209%xmlcat_add() /usr/bin/xmlcatalog --noout --add nextCatalog \"\" %1 /etc/xml/catalog ;
210%xmlcat_del() /usr/bin/xmlcatalog --noout --del %1 /etc/xml/catalog ;
211%xmlcat_add_rewrite /usr/bin/xmlcatalog --noout --add rewriteSystem
212%xmlcat_create() /usr/bin/xmlcatalog --noout --create %1 ;
213%sgmlcat_add() /usr/bin/install-catalog --add %1 %2 > /dev/null ;
214%sgmlcat_del() /usr/bin/install-catalog --remove %1 %2 > /dev/null ;
e00dd7f6 215%docbook_sgmlcat_fix() { for l in \
216'' \
217' -- default decl --' \
218'DTDDECL "-//OASIS//DTD DocBook XML V%2//EN" "../../xml.dcl"' \
219' -- hacks for opensp --' \
220'SYSTEM "file://%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
221'SYSTEM "http://www.oasis-open.org/docbook/xml/%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
222'' \
223; do echo $l; done >> %1 \
224}
225
9c404149
AM
226#-----------------------------------------------------------------
227# find and gzip all files in %{_mandir} and %{infodir}
228#
229# Requires: xargs, find
230#
231#%no_install_post_compress_docs 1
232%__spec_install_post_compress_docs { \
9c404149 233%{!?no_install_post_compress_docs: \
822d4d81 234 echo "Compress man and info pages."; \
9c404149
AM
235 %{?verbose:set -x;} \
236 for i in /usr/share/man /usr/X11R6/man /usr/share/info; do \
237 if [ -d "$RPM_BUILD_ROOT$i" ]; then \
238 find "$RPM_BUILD_ROOT$i" -name \*.bz2 -print | xargs -r %{__bzip2} -df; \
239 find "$RPM_BUILD_ROOT$i" -name \*.gz -print | xargs -r %{__gzip} -dnf; \
240 find "$RPM_BUILD_ROOT$i" -type f -print | xargs -r %{__gzip} -9nf; \
241 fi; \
242 done; \
243} }
244
245#-----------------------------------------------------------------
246# Strip executable binaries and shared object files
247#
248# Requires: find, awk, strip, cut, xargs
249#
250#%no_install_post_strip 1
251%__spec_install_post_strip {%{!?debug: \
252%{!?no_install_post_strip: \
3241033b
ER
253%{?verbose:set -x;} \
254 if [ -d "$RPM_BUILD_ROOT" ]; then \
8f74418b 255 echo "Strip executable binaries, archives and shared object files."; \
b4e3d367 256 filelist=`find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*\.debug" %{?_noautostrip:! -regex "%{_noautostrip}"}`; \
9c404149
AM
257 elfexelist=`echo $filelist | xargs -r file | \
258 awk '/ELF.*executable/ {print $1}' | cut -d: -f1`; \
259 elfsharedlist=`echo $filelist | xargs -r file | \
260 awk '/LF.*shared object/ {print $1}' | cut -d: -f1`; \
8f74418b
MM
261 elfarchiveslist=`echo $filelist | xargs -r file | \
262 awk '/current ar archive/ {print $1}' | cut -d: -f1`; \
9c404149 263 if [ -n "$elfexelist" ]; then \
60ad88f2 264 %{__strip} --remove-section=.note --remove-section=.comment $elfexelist; \
9c404149
AM
265 fi; \
266 if [ -n "$elfsharedlist" ]; then \
60ad88f2 267 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $elfsharedlist; \
8f74418b
MM
268 fi; \
269 if [ -n "$elfarchiveslist" ]; then \
60ad88f2 270 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $elfarchiveslist; \
9f0d4f36 271 fi; \
3241033b 272fi; } \
9c404149 273} }
3241033b 274
fc5d7e20 275#-----------------------------------------------------------------
276# remove all RPATH from executable binaries and shared object files
277#
278# Requires: find, awk, cut, xargs, chrpath, uname
279#
280#%no_install_post_chrpath 1
281%__spec_install_post_chrpath {%{!?debug: \
282%{!?no_install_post_chrpath: \
283 %{?verbose:set -x;} \
9f0d4f36 284if [ -d "$RPM_BUILD_ROOT" ]; then \
fc5d7e20 285echo "Remove RPATH from executable binaries and shared object files."; \
adb39da4 286find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*" %{?_noautochrpath:! -regex "%{_noautochrpath}"} | xargs -r file | \
5bed2bb7 287 awk '/ELF.*(executable.*dynamically linked|shared object)/ {print $1}' | cut -d: -f1 | \
fc5d7e20 288while read file ; do \
289 rpath= ; \
290 chmod u+w "$file"; \
291 for dir in `chrpath -l "$file" | \
3241033b 292 awk '/RPATH=/ { gsub(/.*RPATH=/,""); gsub(/:/," "); print $0 }'` ; do \
fc5d7e20 293 case $dir in \
494e368c 294 /home/* | /tmp/* | /usr/lib | /usr/lib64 | /lib | /lib64 | /usr/local/lib | /usr/local/lib64 | /usr/X11R6/lib | /usr/X11R6/lib64 ) \
fc5d7e20 295 echo "remove-rpath: $dir in $file"; \
296 ;; \
297 * ) \
298 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
299 else rpath="$rpath:$dir" ; fi ; \
300 ;; \
301 esac ; \
302 done ; \
303 if [ "$rpath" = "" ] ; then chrpath -d "$file" > /dev/null ; \
304 else chrpath -r "$rpath" "$file" > /dev/null ; fi ; \
9f0d4f36
JB
305done; \
306fi; } \
fc5d7e20 307} }
3241033b 308
d72c185f 309#-----------------------------------------------------------------
ccb8ae8d 310# Find and gzip all kernel modules
311#
312# Requires: find
313#
314#%no_install_post_compress_modules 1
315%__spec_install_post_compress_modules { \
ccb8ae8d 316%{!?no_install_post_compress_modules: \
3241033b
ER
317 %{?verbose:set -x;} \
318 if [ -d "$RPM_BUILD_ROOT" ]; then \
319 echo "Compress kernel modules if any."; \
320 if test -d $RPM_BUILD_ROOT/lib/modules ; then \
321 find $RPM_BUILD_ROOT/lib/modules -name \*o -type f -print | \
322 xargs -r %{__gzip} -9nf; \
323 find $RPM_BUILD_ROOT/lib/modules -name \*o -type l -printf "%p %l\n" | \
324 while read a b; do ln -sf $b.gz $a.gz; rm -f $a; done; \
325 fi; \
326 fi; \
ccb8ae8d 327} }
9c404149 328
83094b62 329#-----------------------------------------------------------------
0e4cb4dd 330# Update GConf2 schemas
83094b62 331#
332# Requires: GConf2
333#
46885239 334%gconf_schema_install() \
3241033b
ER
335 umask 022; \
336 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" /usr/bin/gconftool-2 --makefile-install-rule /etc/gconf/schemas/%{?1}%{!?1:*.schemas} > /dev/null \
337 %{nil}
46885239 338
339%gconf_schema_uninstall() \
f93109a0 340if [ $1 = 0 ]; then \
3241033b
ER
341 umask 022; \
342 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" /usr/bin/gconftool-2 --makefile-uninstall-rule /etc/gconf/schemas/%{?1} > /dev/null \
f93109a0 343fi \
344%{nil}
345
346#-----------------------------------------------------------------
347# Update desktop MIME database
c0a4caa0 348# requires: desktop-file-utils
f93109a0 349#
820792a9 350%update_desktop_database_post() {{ \
f93109a0 351 umask 022; \
352 /usr/bin/update-desktop-database; \
4565b525 353}}
f93109a0 354
09e3522b 355%update_desktop_database_postun() {{ \
f93109a0 356if [ $1 = 0 ]; then \
357 umask 022; \
358 /usr/bin/update-desktop-database; \
359fi \
4565b525 360}}
f93109a0 361
362#-----------------------------------------------------------------
363# Update scrollkeeper database
364# requires: scrollkeeper
365#
366%scrollkeeper_update_post() \
f93109a0 367 /usr/bin/scrollkeeper-update -q; \
368 %{nil}
369
370%scrollkeeper_update_postun() \
371if [ $1 = 0 ]; then \
f93109a0 372 /usr/bin/scrollkeeper-update -q; \
373fi \
374%{nil}
375
376#-----------------------------------------------------------------
377# Run ldconfig after installing/deinstalling libraries
378#
379%ldconfig_post() \
380 /sbin/ldconfig; \
381 %{nil}
382
383%ldconfig_postun() \
f93109a0 384 /sbin/ldconfig; \
b430f866 385 %{nil}
83094b62 386
9c404149
AM
387#-----------------------------------------------------------------
388# post %install sequence:
389# - autodeps exceptions
390# - compress all man and info pages,
391# - strip all ELF executables and ELF shared objects if not %debug.
8f74418b 392# - compress kernel modules if any
9c404149
AM
393
394###################################################################
395# Requires/Provides automation
396# exceptions system by Jacek Konieczny <jajcus@pld.org.pl>
338726a6 397#
2892b5df
JB
398%__noautoreqfiles %(sed -e s'/#.*//' /etc/rpm/noautoreqfiles)%{?_noautoreqfiles: %{_noautoreqfiles}}
399%__noautoprovfiles %(sed -e s'/#.*//' /etc/rpm/noautoprovfiles)%{?_noautoprovfiles: %{_noautoprovfiles}}
400%__noautoreq %(sed -e s'/#.*//' /etc/rpm/noautoreq)%{?_noautoreq: %{_noautoreq}}
401%__noautoreqdep %(sed -e s'/#.*//' /etc/rpm/noautoreqdep)%{?_noautoreqdep: %{_noautoreqdep}}
402%__noautoprov %(sed -e s'/#.*//' /etc/rpm/noautoprov)%{?_noautoprov: %{_noautoprov}}
338726a6
JB
403#%_noautocompressdoc %{nil}
404#
8f74418b
MM
405%_missing_doc_files_terminate_build 1%{nil}
406%_unpackaged_files_terminate_build %{nil}
8781dc74 407# (X)emacs support
d77dcb61 408%___emacs_lispdir_helper -batch -q -eval '(while load-path (princ (concat (car load-path) "\\n")) (setq load-path (cdr load-path)))' 2> /dev/null|sed -n '/\\(.*\\/x\\?emacs\\/site-lisp\\)\\/\\?$/{s,,\\1,p;q;}'
8781dc74
AF
409%_emacs_lispdir %(emacs %___emacs_lispdir_helper)
410%_xemacs_lispdir %(xemacs %___emacs_lispdir_helper)
25043cd4 411
02b58f60
JK
412%__php_provides %{nil}
413%__php_requires %{nil}
414%__perl_provides %{nil}
415%__perl_requires %{nil}
fa3497cd 416%__mono_provides %{nil}
417%__mono_requires %{nil}
25043cd4
AF
418
419# Perl specific macro definitions.
34f59add
ER
420%perl_privlib %(eval "`%{__perl} -V:installprivlib`"; echo $installprivlib)
421%perl_archlib %(eval "`%{__perl} -V:installarchlib`"; echo $installarchlib)
422%perl_vendorlib %(eval "`%{__perl} -V:installvendorlib`"; echo $installvendorlib)
c853f847 423%perl_vendorarch %(eval "`%{__perl} -V:installvendorarch`"; echo $installvendorarch)
34f59add
ER
424%perl_sitelib %(eval "`%{__perl} -V:installsitelib`"; echo $installsitelib)
425%perl_sitearch %(eval "`%{__perl} -V:installsitearch`"; echo $installsitearch)
25043cd4 426
45c00b39 427# Ruby
c5472d67
ER
428%ruby_archdir %(ruby -r rbconfig -e 'print Config::CONFIG["archdir"]' 2>/dev/null || echo ERROR)
429%ruby_ridir %(ruby -r rbconfig -e 'include Config; print File.join(CONFIG["datadir"], "ri", CONFIG["ruby_version"], "system")' 2>/dev/null || echo ERROR)
430%ruby_rubylibdir %(ruby -r rbconfig -e 'print Config::CONFIG["rubylibdir"]' 2>/dev/null || echo ERROR)
431%ruby_sitearchdir %(ruby -r rbconfig -e 'print Config::CONFIG["sitearchdir"]' 2>/dev/null || echo ERROR)
432%ruby_sitelibdir %(ruby -r rbconfig -e 'print Config::CONFIG["sitelibdir"]' 2>/dev/null || echo ERROR)
433%ruby_version %(ruby -r rbconfig -e 'print Config::CONFIG["ruby_version"]' 2>/dev/null || echo ERROR)
669604db
ER
434%ruby_ver_requires_eq Requires: ruby(ver) = %ruby_version
435%ruby_mod_ver_requires_eq Requires: ruby-modules(ver) = %ruby_version
45c00b39 436
c853f847 437%php_pear_dir %{_datadir}/pear
25043cd4 438
c1b2705c
ER
439# directory where php includes are installed on system.
440%__php_includedir /usr/include/php
0c5d1b9b 441# extract php/zend api versions
e9b6395a 442%php_major_version %(awk '/#define PHP_MAJOR_VERSION/{print $3}' %{__php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)
c1b2705c 443%php_api_version %(awk '/#define PHP_API_VERSION/{print $3}' %{__php_includedir}/main/php.h 2>/dev/null || echo ERROR)
68b68193 444%php_debug %(awk '/#define ZEND_DEBUG/{print $3}' %{__php_includedir}/main/php_config.h 2>/dev/null || echo ERROR)
c1b2705c
ER
445%zend_module_api %(awk '/#define ZEND_MODULE_API_NO/{print $3}' %{__php_includedir}/Zend/zend_modules.h 2>/dev/null || echo ERROR)
446%zend_extension_api %(awk '/#define ZEND_EXTENSION_API_NO/{print $3}' %{__php_includedir}/Zend/zend_extensions.h 2>/dev/null || echo ERROR)
c0ac7203 447%zend_zts %(Z=$(grep -sc '^#define ZTS 1' %{__php_includedir}/main/php_config.h); echo ${Z:-ERROR})
c1b2705c
ER
448
449# helper macro
f952c0f3 450%__php_api_requires(v:) Requires: php%{-v*}(%{expand:%1}) = %{expand:%{%{!?2:%{1}}%{?2}}}
c1b2705c
ER
451
452# macros for public use
453# for php extensions (php-pecl)
68b68193 454%requires_php_extension %{__php_api_requires modules_api php_api_version} \
f952c0f3
ER
455%{__php_api_requires -v %php_major_version debug php_debug} \
456%{__php_api_requires -v %php_major_version thread-safety zend_zts}
68b68193 457
c1b2705c
ER
458# for zend extensions
459%requires_zend_extension %{__php_api_requires zend_module_api} \
68b68193 460%{__php_api_requires zend_extension_api} \
f952c0f3
ER
461%{__php_api_requires -v %php_major_version debug php_debug} \
462%{__php_api_requires -v %php_major_version thread-safety zend_zts}
c1b2705c 463
25043cd4
AF
464# Python specific macro definitions.
465# python main version
3241033b 466%py_ver %(python -c "import sys; print sys.version[:3]")
25043cd4
AF
467
468# directories
3241033b
ER
469%py_prefix %(python -c "import sys; print sys.prefix")
470%py_libdir %{py_prefix}/%{_lib}/python%{py_ver}
ef7ec0a8 471%py_scriptdir %{py_prefix}/share/python%{py_ver}
3241033b 472%py_incdir /usr/include/python%{py_ver}
ef7ec0a8
JK
473%py_sitedir %{py_libdir}/site-packages
474%py_sitescriptdir %{py_scriptdir}/site-packages
3241033b 475%py_dyndir %{py_libdir}/lib-dynload
25043cd4
AF
476
477# pure python modules compilation
3241033b 478%py_comp python -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
25043cd4 479
3241033b 480%py_ocomp python -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
25043cd4
AF
481
482# Software written in Python language require Python with main version
e63cd81d 483%pyrequires_eq() Requires: %1
25043cd4 484
f12c2314
AF
485# Hardlink binary identical .pyc and .pyo files
486# (idea by glen <at> pld-linux <dot> org)
487%__spec_install_post_py_hardlink {\
d56b7e24 488%{!?no_install_post_py_hardlink: \
f12c2314
AF
489[ ! -d "$RPM_BUILD_ROOT" ] || find "$RPM_BUILD_ROOT" -name '*.pyc' | while read a; do \
490 b="$(echo $a|sed -e 's/.pyc$/.pyo/')"; \
491 if cmp -s "$a" "$b"; then \
492 ln -f "$a" "$b"; \
493 fi; \
494done \
495} }
496
9227b3f9 497# remove python sources, so that check-files won't complain
f12c2314
AF
498# (idea by glen <at> pld-linux <dot> org)
499%py_postclean() \
0f82e280 500for d in %{py_sitescriptdir} %{py_sitedir} %*; do \
820792a9 501 [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 | xargs -0r -l512 rm;\
f12c2314
AF
502done \
503%{nil}
504
0fc5cff8 505# depmod macro
506%depmod() { \
f6148427 507umask 022; \
0fc5cff8 508if [ -e /boot/System.map-%1 ]; then \
3241033b 509 /sbin/depmod -a -F /boot/System.map-%1 %1; \
0fc5cff8 510else \
3241033b
ER
511 if [ -e /boot/System.map ]; then \
512 /sbin/depmod -a -F /boot/System.map %1; \
513 else \
514 /sbin/depmod -a %1; \
515 fi \
0fc5cff8 516fi; \
517}
518
2afc6e64 519# XMMS specific macros
3241033b
ER
520%xmms_prefix %(xmms-config --prefix 2>/dev/null)
521%xmms_exec_prefix %(xmms-config --exec-prefix 2>/dev/null)
522%xmms_version %(xmms-config --version 2>/dev/null)
523%xmms_datadir %(xmms-config --data-dir 2>/dev/null)
524%xmms_plugindir %(xmms-config --plugin-dir 2>/dev/null)
525%xmms_visualization_plugindir %(xmms-config --visualization-plugin-dir 2>/dev/null)
526%xmms_input_plugindir %(xmms-config --input-plugin-dir 2>/dev/null)
527%xmms_output_plugindir %(xmms-config --output-plugin-dir 2>/dev/null)
528%xmms_effect_plugindir %(xmms-config --effect-plugin-dir 2>/dev/null)
529%xmms_general_plugindir %(xmms-config --general-plugin-dir 2>/dev/null)
2afc6e64 530
d1537778
PS
531%_target_base_arch %(echo %{_target_cpu} | sed 's/i.86/i386/;s/athlon/i386/;s/pentium./i386/;s/amd64/x86_64/;s/ia32e/x86_64/')
532
848c0d68 533# user/group checking macros
534#
535# Usage:
536# %userremove myuser
537#
538%userremove /usr/lib/rpm/user_group.sh user del
539%groupremove /usr/lib/rpm/user_group.sh group del
540#
541# Usage:
542# if %usertestrm myuser; then
543# /usr/sbin/userdel -r myuser
544# Note:
545# use these macros only if you need to call userdel/groupdel with
546# a non-standard option or take an extra action; otherwise use the
547# %userremove/%groupremove macros
548#
549%usertestrm /usr/lib/rpm/user_group.sh user testrm
550%grouptestrm /usr/lib/rpm/user_group.sh group testrm
08d9b1f6
JK
551# user group membership management macros
552#
553# Usage:
554# %addusertogroup myuser agroup
555#
556%addusertogroup /usr/lib/rpm/user_group.sh user addtogroup
72fcfcb3 557
558# banner support (useful in {pre,post}{,un} and triggers)
559#
560# Usage:
aa41c920 561# %banner name [-a] [-e] [-n] [-tn] <<EOF
72fcfcb3 562# the banner text, the banner text
aa41c920
ER
563# the banner text, and following line
564#EOF
565# You can use any form of here-document, <<'EOF' <<-EOT will do.
566# NOTE: if your use "<<-EOF", then You can actually indent inside here-document.
567#
72fcfcb3 568# -a - append to the banner
a8b9562a 569# -e - send to stderr instead of stdout
628754cb 570# -n - no show banner (overrides -t)
571# -t - show only, if RPM_SCRIPTVERBOSITY >= n; default n=5
aa41c920 572%banner(aent:) \
1b334fe4 573RPM_SCRIPTVERBOSITY=5 \
574[ -r /etc/sysconfig/rpm ] && . /etc/sysconfig/rpm \
575if [ -x /usr/bin/banner.sh ]; then \
aa41c920 576 CMD="/usr/bin/banner.sh %{-e:--stderr} %{!-n:$([ $RPM_SCRIPTVERBOSITY -ge %{-t:%{-t*}}%{!-t:5} ] && echo -s)} %{!-a:-m}%{-a:-M} %1" \
1b334fe4 577else \
a8b9562a 578 CMD="cat%{-e: >&2}" \
1b334fe4 579fi \
c2e886e1 580eval $CMD %2%{?3: %3} \
72fcfcb3 581%nil
628754cb 582
90627280
ER
583# useradd/groupadd macros written by glen@pld-linux.org.
584# All rights reserved. Permission to copy is hereby granted.. yada, yada, yada
585#
586# Usage:
587# %useradd [-P package] [-u uid] [-d home_dir] [-s shell] [-c comment]
588# [-g initial_group] [-G group[,...]] login
589#
590# -u uid. REQUIRED
591# -g gid/group. REQUIRED
592# -s defaults to /bin/false
593# -d defaults to /usr/share/empty
594# -c No default
595# -r is accepted but ignored (it's always set)
6bd4c218 596# -k skeleton dir. defaults to /usr/share/empty
90627280
ER
597# rpm specific flags
598# -P package name. defaults to %{name}
599#
90627280 600%useradd(c:d:e:f:g:G:Mmk:op:s:u:rP:) \
9ba02ba9
ER
601%{!-u:%{error:useradd: Required argument -u missing}} \
602%{!-g:%{error:useradd: Required argument -g missing}} \
603%{!?1:%{error:useradd: Required parameter login missing}} \
90627280
ER
604if [ -n "`/bin/id -u %{expand:%{%{#}}} 2>/dev/null`" ]; then \
605 if [ "`/bin/id -u %{expand:%{%{#}}}`" != "%{-u*}" ]; then \
606 echo "Error: user %{expand:%{%{#}}} doesn't have uid=%{-u*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
607 exit 1 \
608 fi \
609else \
610 echo "Adding user %{expand:%{%{#}}} UID=%{-u*}." \
611 /usr/sbin/useradd \\\
b5a7d552 612 %{-m:-m -k %{-k*}%{!-k:/usr/share/empty}} \\\
90627280
ER
613 -u %{-u*} \\\
614 -r \\\
615 -d %{-d*}%{!-d:/usr/share/empty} \\\
616 -s %{-s*}%{!-s:/bin/false} \\\
840e7b00 617 %{-c:-c "%(set -- %{-c*} %{*}; echo $1)"}\\\
90627280
ER
618 -g %{-g*} \\\
619 %{-M} \\\
620 %{-G:-G %{-G*}} \\\
840e7b00 621 %{expand:%{%{#}}} 1>&2 \
90627280
ER
622fi;
623
90627280
ER
624# Usage:
625# %groupadd [-P package] [-g gid] group
626#
627# -g gid. REQUIRED
628#
629# Sample:
630# %groupadd -P %{name}-base -g %{gid} %{name}
631
632%groupadd(g:P:rfo) \
9ba02ba9
ER
633%{!-g:%{error:groupadd: Required argument -g missing}} \
634%{!?1:%{error:groupadd: Required parameter group missing}} \
90627280
ER
635if [ -n "`/usr/bin/getgid %{1}`" ]; then \
636 if [ "`/usr/bin/getgid %{1}`" != "%{-g*}" ]; then \
637 echo "Error: group %{1} doesn't have gid=%{-g*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
638 exit 1 \
639 fi \
640else \
641 echo "Adding group %{1} GID=%{-g*}." \
840e7b00 642 /usr/sbin/groupadd -g %{-g*} -r %{1} 1>&2 \
90627280 643fi;
7cb77741
ER
644
645# apache_config_{install/uninstall} macros written by glen@pld-linux.org.
646# All rights reserved. Permission to copy is hereby granted.. yada, yada, yada
647#
648# The config is installed/removed inside trigger, this means that you can any
649# time install apache1 or apache package and the configuration file is updated.
650# if you don't need the config for various reason for specific apache, just
651# remove the symlink from apache config directory. the trigger will not put the
652# config again to that version of apache. In other words the config is linked
653# to apache config directory on first install of PACKAGE or apache.
654#
655# should be called in trigger body:
656# %triggerin -- apache1 >= 1.3.33-2
657# %apache_config_install -v 1
658#
659# Add package's apache config to apache config.
660#
661# Usage:
662# %apache_config_install -v {1|2} -c %{_sysconfdir}/apache-%{name}.conf -n 99
663#
664# -v REQUIRED: specify apache version. can be 1 or 2.
665# -c OPTIONAL: specify full path to PACKAGE's config. Defaults to %{_sysconfdir}/apache-%{name}.conf.
666# -n OPTIONAL: specify config "slot". defaults to 99
13ee223c 667# -f OPTIONAL: force symlink creation regardless if package was upraded. useful in triggers
7cb77741
ER
668#
669# Internal macros. don't use ;).
670# expands apache config dir by apache version at build time.
671%__apache_confdir() %(if [ %{1} = 1 ]; then echo /etc/apache/conf.d; elif [ %{1} = 2 ]; then echo /etc/httpd/httpd.conf; else echo >&2 Unknown apache version specified; fi)
672# expands apache service name by apache version at build time.
673%__apache_svcname() %(if [ %{1} = 1 ]; then echo apache; elif [ %{1} = 2 ]; then echo httpd; else echo >&2 Unknown apache version specified; fi)
674
13ee223c 675%apache_config_install(fv:c:n:) \
7cb77741
ER
676%{!-v:%{error:apache_config_install: Required argument -v missing}} \
677%{?debug:set -x; echo "apache_config_install:%{-v*} %{name}-%{version}-%{release} 1:[$1]; 2:[$2]"} \
13ee223c 678if [ -n "%{-f:1}" ] || ([ "$1" = "1" ] && [ "$2" = "1" ]) && [ -d %{__apache_confdir %{-v*}} ]; then\
7cb77741
ER
679 ln -sf %{-c*}%{!-c:%{_sysconfdir}/apache-%{name}.conf} %{__apache_confdir %{-v*}}/%{-n*}%{!-n:99}_%{name}.conf\
680fi\
e5a1a393 681# reload apache if the config symlink is there\
de11f042 682if [ -L %{__apache_confdir %{-v*}}/%{-n*}%{!-n:99}_%{name}.conf ]; then\
ab251261
ER
683 # additionally don't reload if target package (the webserver) is upgraded, as webserver is restarted anyway in %post \
684 if [ "$2" != "2" ] && [ -f /var/lock/subsys/%{__apache_svcname %{-v*}} ]; then\
e5a1a393 685 /etc/rc.d/init.d/%{__apache_svcname %{-v*}} reload 1>&2\
7cb77741
ER
686 fi\
687fi\
688%{nil}
689
690# Remove package's apache config from apache config.
691#
692# Usage:
693# %apache_config_uninstall -v {1|2} -n 99
694#
695# -v REQUIRED: specify apache version. can be 1 or 2.
696# -n OPTIONAL: specify config "slot". defaults to 99
697%apache_config_uninstall(v:n:) \
698%{!-v:%{error:apache_config_uninstall: Required argument -v missing}} \
699%{?debug:set -x; echo "apache_config_uninstall:%{-v*} %{name}-%{version}-%{release}: 1:[$1]; 2:[$2]"} \
feb15ceb 700# remove link if either of the packages are gone \
7cb77741
ER
701if [ "$1" = "0" ] || [ "$2" = "0" ]; then \
702 if [ -L %{__apache_confdir %{-v*}}/%{-n*}%{!-n:99}_%{name}.conf ]; then \
703 rm -f %{__apache_confdir %{-v*}}/%{-n*}%{!-n:99}_%{name}.conf \
704 if [ -f /var/lock/subsys/%{__apache_svcname %{-v*}} ]; then \
e5a1a393 705 /etc/rc.d/init.d/%{__apache_svcname %{-v*}} reload 1>&2 \
7cb77741
ER
706 fi \
707 fi \
708fi \
709%{nil}
710
7c50f037 711# webapp macros
35663282
ER
712#
713# The config is installed/removed inside trigger, this means that you can any
714# time install apache1/apache/lighttpd package and the configuration file is
715# updated. if you don't need the config for various reason for specific
716# webserver, just remove the symlink from config directory using webapp
717# program. the trigger will not recreate the symlink on upgrades. In other
718# words the config is linked to webserver config directory on first install of
719# PACKAGE or WEBSERVER.
720#
7c50f037
ER
721# Add package's webserver config to webserver webapps dir.
722# Usage:
df979130 723# %webapp_register WEBSERVER WEBAPP
35663282
ER
724#
725%webapp_register() \
726%{?debug:set -x; echo "webapp_register: %{name}-%{version}-%{release} 1:[$1]; 2:[$2]"} \
727if [ "$1" = "1" ] && [ "$2" = "1" ]; then\
728 /usr/sbin/webapp register %1 %2\
729fi\
694a8f2e 730# reload webserver if the config symlink is there and skip reload if webserver is upgraded\
6ec4309e
ER
731if [ -L /etc/%1/webapps.d/%2.conf ] && [ "$2" -lt "2" ]; then\
732 %{expand:%service %%1 reload}\
35663282
ER
733fi\
734%{nil}
735
736# Remove package's config from webserver webapps dir.
35663282 737# Usage:
531c0efc
ER
738# %webapp_register [-f] WEBSERVER WEBAPP
739%webapp_unregister(f) \
35663282
ER
740%{?debug:set -x; echo "webapp_unregister: %{name}-%{version}-%{release}: 1:[$1]; 2:[$2]"} \
741# remove link if either of the packages are gone \
531c0efc 742if [ -n "%{-f:1}" ] || [ "$1" = "0" ] || [ "$2" = "0" ] && [ -L /etc/%1/webapps.d/%2.conf ]; then \
df979130 743 /usr/sbin/webapp unregister %1 %2\
6ec4309e 744 %{expand:%service %%1 reload}\
35663282
ER
745fi \
746%{nil}
747
d87a3f0b
ER
748# see browser-plugins.spec / template-browser-plugin.spec
749# written by glen@pld-linux.org.
bba6d017 750%nsplugin_install(d:f) { \
d87a3f0b 751# create link if it's first install of either of the packages \
bba6d017 752if [ -n "%{-f:1}" ] || ([ "$1" = "1" ] && [ "$2" = "1" ] && [ -d %{-d*} ]); then \
d87a3f0b
ER
753( \
754%( \
755 for file in %{*}; do \
756 echo echo Installing $file to %{-d*}; \
757 echo "ln -sf %{_libdir}/browser-plugins/$file %{-d*};"; \
758 done ) \
759) | ( %banner -t 5 -e %{name}-in ); fi; \
760}
761
933139a5 762%nsplugin_uninstall(d:) { \
d87a3f0b
ER
763# remove link if either of the packages are gone \
764if [ "$1" = "0" ] || [ "$2" = "0" ]; then \
765( \
766%( \
767 for file in %{*}; do \
768 echo echo Removing $file from %{-d*}; \
769 echo "rm -f %{-d*}/$file;"; \
770 done ) \
771) | ( %banner -t 5 -e %{name}-un ); fi; \
772}
462b26fa
ER
773
774# service macro.
775#
776# calls usual service restart on package %post, but skips the restart if
777# administrator has disabled automatic service restarts in either global
778# /etc/sysconfig/rpm or per service /etc/sysconfig/SERVICE file.
779#
780# written by glen@pld-linux.org.
781# All rights reserved. Permission to copy is hereby granted.. yada, yada, yada
782#
783# Usage:
3e913a30 784# %service [-q] SERVICE ACTION ["SERVICE NICE DESCRIPTION"]
462b26fa
ER
785#
786# -q be silent when service isn't started (for postun scriplets)
787#
8b781cff 788%service(q) {{%(export quiet=%{-q:1}; /usr/lib/rpm/service_generator.sh %{*}) };}
This page took 0.285022 seconds and 4 git commands to generate.